﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Threading;
using System.Activities;
using Microsoft.TeamFoundation.Client;
using Microsoft.TeamFoundation.Build.Client;
using Microsoft.TeamFoundation.Build.Workflow.Tracking;
using Microsoft.TeamFoundation.Build.Workflow;
using System.ComponentModel;
using Microsoft.TeamFoundation.VersionControl.Client;
using Microsoft.TeamFoundation.Build.Workflow.Activities;

namespace TFSBuildActivitiesLibrary
{
    /// <summary>
    /// Code activity that adds new build to build queue.
    /// </summary>
    [BuildActivity(HostEnvironmentOption.All)]
    public sealed class QueueNewBuildEnd : CodeActivity<IBuildDetail>
    {
        /// <summary>
        /// Sets the parent build detail object.
        /// </summary>
        /// <value>
        /// The build detail.
        /// </value>
        [RequiredArgument]
        public InArgument<IQueuedBuild> queuedBuild { get; set; }
        /// <summary>
        /// Sets the build name for a child build.
        /// </summary>
        /// <value>
        /// The name of the build.
        /// </value>
        [DefaultValue("Undefined")]
        public InArgument<string> buildQuality { get; set; }

        /// <summary>
        /// When implemented in a derived class, performs the execution of the activity.
        /// </summary>
        /// <param name="context">The execution context under which the activity executes.</param>
        protected override IBuildDetail Execute(CodeActivityContext context)
        {
            IQueuedBuild qbuild = context.GetValue(this.queuedBuild);
            string strBuildQuality = context.GetValue(this.buildQuality);

            if (qbuild == null) return null;
            Utilities.EndExecute(context, qbuild, strBuildQuality);

            return qbuild.Build;
        }
    }
}
